<div class="secret">
  <form [ngrxFormState]="form" (submit)="submitForm.emit()">
    <app-non-field-messages
      *ngIf="errorMessage"
      [messages]="[errorMessage]"
    ></app-non-field-messages>

    <div class="secret__details">
      <div class="form-field secret__field">
        <app-text-field
          label="Name"
          [ngrxFormControl]="form.controls.name"
          [isFormSubmitted]="form.isSubmitted"
          [isLarge]="false"
          inlineError="Required"
        ></app-text-field>
      </div>

      <app-multiselect
        label="Members"
        [userId]="userId"
        [searchControl]="form.controls.searchUsers"
        [listItems]="listItems"
        [confirmRemovalMessage]="
          'If you confirm here and then press ‘Save Group’, you will be removed from the group.\n\nThe group will live on with the other members.'
        "
        [singleItemIsRemovable]="isNew"
        [keyControls]="keyControls"
        [searchFieldValidationPattern]="searchFieldValidationPattern"
        [invalidSearchFieldText]="invalidSearchFieldText"
        [noSearchFieldMatchText]="noSearchFieldMatchText"
        [noListItemsText]="noListItemsText"
        [fewListItemsText]="fewListItemsText"
        [allListItemsSelectedText]="allListItemsSelectedText"
        [justAddedText]="justAddedText"
        (toggleKeyControls)="toggleKeyControls.emit()"
        (addListItem)="addUserToGroup.emit($event)"
        (removeListItem)="removeUserFromGroup.emit($event)"
      ></app-multiselect>

      <div class="secret__buttons">
        <button
          *ngIf="!isNew"
          class="button button--text button--text-danger group-form__delete-btn"
          type="button"
          (click)="onDelete()"
        >
          Delete Group
        </button>
        <button
          *ngIf="isNew"
          class="button button--text button--text-danger group-form__cancel-btn"
          type="button"
          (click)="cancelForm.emit()"
        >
          Cancel
        </button>

        <button
          [class.button--is-saving]="isUpdating"
          [disabled]="isUpdating"
          type="submit"
          class="button button--primary group-form__save-btn"
        >
          Save Group
        </button>
      </div>
    </div>
    <div
      class="secret__progress-bar"
      [class.secret__progress-bar--is-saving]="isUpdating"
      [class.secret__progress-bar--is-saved]="isUpdated"
    ></div>
  </form>
</div>
